create table trains
(
	trainno int,
	traindate datetime,
	totalseats int,
	constraint tpk primary key(trainno,traindate)
)
create procedure tins
(
	@tno int,
	@tdate datetime,
	@tseats int
)
as
insert into trains values(@tno,@tdate,@tseats)
exec tins 1001,'2/1/07',300
exec tins 1001,'2/2/07',300
exec tins 1002,'2/2/01',20

create table reservation
(
	ticketno int,
	noofseats int,
	tdate datetime,
	trainno int,
	rdate datetime,
	constraint rfk foreign key(trainno,tdate)
	references trains(trainno,traindate)
)
create procedure rins
(
	@tdate datetime,
	@tno int,
	@ns int
)
as
declare @lastno int,@newno int
select @lastno=max(ticketno)from reservation
if @lastno is null
begin
	set @newno=101
end
else
begin
	set @newno=@lastno+1
end
insert into reservation values
(@newno,@ns,@tdate,@tno,getdate())

create trigger tupdate
on reservation
for insert
as
declare @seats int,@tdate datetime,@tno int
select @seats=noofseats,@tdate=tdate,@tno=trainno from inserted
declare @availseats int
select @availseats=totalseats from trains
where trainno=@tno and traindate=@tdate
if @seats<=@availseats
begin
	update trains set totalseats=totalseats-@seats
	where trainno=@tno and traindate=@tdate
end
else
begin
print 'available seats are'
print @availseats
rollback transaction
end
exec rins '2/1/07',1001,12
exec rins '2/1/07',1001,300
select*from trains
select*from reservation